local powertips = {
    {msg = "Powerlap gives you a powerup every lap completed, most of them have a timer when used, the powerups with \130a yellow border \128 can be used manually by pressing item, the \131 ones with green borders \128 are used during certain conditions, like getting an item, the \134 ones with grey borders \128 are instant", cvartrue = "powerlap"},
	{msg = "Powerups with a \131green \128border can be exchanged with a sneaker by holding ITEM (default button), you can only exchange if you have no item and if you're not first!", cvartrue = "powerlap"},
	{msg = "The \131protect shield \128look and \134super mode color can be changed by typing \135pl_shieldtype \128 and \135pl_supercolor in console. Those values can be changed in 'powerlap.cfg' file located in your luafiles folder", cvartrue = "powerlap"},
	{msg = "You can change the button to use or drop a powerup by typing \135pl_button \128in console, but you still have to use an item even if you binded in one of your custom buttons", cvartrue = "powerlap"},
    {msg = "Some powerups timers will run twice as fast if you're first, to prevent frontrunning with them", cvartrue = "powerlap"},
	{msg = "Some Powerups can have their timer extended if you USE them before completing a lap, take adventage of the extended duration of the \130mini boost \128or \130mini hyudoro \128 before starting the next lap", cvartrue = "powerlap"},
	{msg = "Powerlap varaibles can be changed in your 'powerlap.cfg' file located in your luafiles folder, check the message board topic of powerlap for more info", cvartrue = "powerlap"},
	{msg = "\130Mini boost \128and \130long boost \128powerups gives you a small boost for a short time, but remember it's like a drift boost, so you can't cut offroad with that", cvartrue = "powerlap"},
	{msg = "\130Spring drop \128powerup let you hover a little by dropping a spring on you, you can use this powerup as a mean trap to lunch your opponents or take impossible shortcuts, but don't end up stuck out of bounds!", cvartrue = "powerlap"},
	{msg = "\130Punch bumper \128powerup allows you to wipe others by touching them, to encourage you at bumping others, it gives a small boost in speed and acceleration", cvartrue = "powerlap"},
	{msg = "\130Growing seed \128gives the effect of grow, but the powerup charges over time, the longer you held, the more bigger and longer grow will be. It charges faster if you're far from first", cvartrue = "powerlap"},
	{msg = "\131Bigger item \128increases the size of some items, and also affect invincibility and grow", cvartrue = "powerlap"},
	{msg = "\131Curse attack \128will shrink the player who got hit by your items, it also had a short timer before the powerup gets used, letting you shrinking multiple victims with your decabananas or ballhogs", cvartrue = "powerlap"},
	{msg = "\134Super mode \128is the rarest powerup of the bunch, it's also hard to control, do your best to make a comeback!", cvartrue = "powerlap"},
	{msg = "\134Item recollect \128gives you the item you just took damage of, it also get stored if you already had one, like a second item!", cvartrue = "powerlap"},
	{msg = "Chocolatine", humor = true},
	{msg = "Titou is a aqua colored rabbit who knows the magic of ice, wind, light and healing spells. She's good on fights and use her ears for melee combat or to fly. She likes booping noses and her favorite animal type are dragons", humor = true},
	{msg = "I was thinking about why so many Diggles participate in 'frontrunning' The reason is diggle's lack of work ethic ('go speed' rather than 'do acceleration') and, in a Petersonian sense, to elevate alternative runners in the kartplace ('fastest karter')", humor = true},
}

local mod = {disp = "powerlap", var = "powerlap"}

local loaded = false
addHook("MapLoad", function()
if loaded == false
    if HM_Scoreboard_AddTip
		-- do a loop to add them all
		for key,i in ipairs(powertips) do
			HM_Scoreboard_AddTip(i);
		end
    loaded = true
    end
    if HM_Scoreboard_AddMod
        HM_Scoreboard_AddMod({disp = "powerlap", var = "powerlap"});
    loaded = true
    end
end
end)