-- HUD --
local powerupName = "Nothing";
local txtmovX = 0;
local txttrans = V_10TRANS;
local txtcolor = 0;
local growtxtcolor = 0;

-- splitscreen stuff
-- 320 x 200
local powpositionX = 0;
local powpositionY = 0;
local powscaled = 0;
local powtxtsize = "";
local powflagpos = nil;
local powbutton = "non init?";


local function powerlaphud(v, player)
    if cv_powerlap.value
    if not (player and player.valid) return end;
	if not (player.powerlap) return end;
    --local first = {x = player.powerlap.firstplace.x, y = player.powerlap.firstplace.y};
    local first = {x = plap.first.x, y = plap.first.y}
    local icontrans = V_HUDTRANS;

    -- blinking effect
    --if displayplayers[0] == player -- only run once for spitscreen
    if player.powerlap.hudtime > TICRATE * 8 or player.powerlap.inuse
        if leveltime%4 == 1 icontrans = V_HUDTRANSHALF;
        elseif leveltime%4 == 3 icontrans = V_90TRANS;
        else icontrans = V_HUDTRANS end;
    else icontrans = V_HUDTRANS
    end;
    --end

    -- changes color for charging growing seed
    if player.powerlap.growtime < 300 growtxtcolor = V_STEELMAP;
    elseif player.powerlap.growtime < 600 growtxtcolor = V_YELLOWMAP;
    elseif player.powerlap.growtime < 1000 growtxtcolor = V_TEAMAP;
    else growtxtcolor = V_SKYMAP;
    end

    if (splitscreen == 0)
        powpositionX = 30; powpositionY = 55; powscaled = 0; powtxtsize = nil; powflagpos = V_SNAPTOTOP|V_SNAPTOLEFT;
    elseif (splitscreen == 1)
        if (displayplayers[0] == player) powpositionX = 30; powpositionY = 50; powscaled = 0; powtxtsize = "thin"; powflagpos = V_SNAPTOTOP|V_SNAPTOLEFT; end;        
        if (displayplayers[1] == player) powpositionX = 30; powpositionY = 150; powscaled = 0; powtxtsize = "thin"; powflagpos = V_SNAPTOLEFT; end;
    elseif (splitscreen >= 2)
        if (displayplayers[0] == player) powpositionX = 5; powpositionY = 30; powscaled = FRACUNIT*2/5; powtxtsize = "small"; powflagpos = V_SNAPTOTOP|V_SNAPTOLEFT; end;        
        if (displayplayers[1] == player) powpositionX = 300; powpositionY = 30; powscaled = FRACUNIT*2/5; powtxtsize = "small"; powflagpos = V_SNAPTOTOP|V_SNAPTORIGHT; end; 
        if (displayplayers[2] == player) powpositionX = 5; powpositionY = 130; powscaled = FRACUNIT*2/5; powtxtsize = "small"; powflagpos = V_SNAPTOLEFT; end; 
        if (displayplayers[3] == player) powpositionX = 300; powpositionY = 130; powscaled = FRACUNIT*2/5; powtxtsize = "small"; powflagpos = V_SNAPTORIGHT; end; 
    end

    -- set icon and text
    if (player.powerlap.item == plap.powitems.miniboost) -- mini boost
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[1]), icontrans|powflagpos)
     powerupName = "Mini\nBoost"; txtcolor = 0;
    elseif (player.powerlap.item == plap.powitems.longboost) -- long boost
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[2]), icontrans|powflagpos)
     powerupName = "Long\nBoost"; txtcolor = V_ORANGEMAP;
    elseif (player.powerlap.item == plap.powitems.springdrop) --spring drop
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[3]), icontrans|powflagpos)
     powerupName = "Spring\nDrop"; txtcolor = V_YELLOWMAP;
    elseif (player.powerlap.item == plap.powitems.protectshield) -- protect shield
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[4]), icontrans|powflagpos)
     powerupName = "Protect\nShield"; txtcolor = V_GREENMAP;
    elseif (player.powerlap.item == plap.powitems.minihyudoro) -- mini hyudoro
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[5]), icontrans|powflagpos)
     powerupName = "Mini\nHyudoro"; txtcolor = V_STEELMAP;
    elseif (player.powerlap.item == plap.powitems.biggeritem) -- bigger item
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[6]), icontrans|powflagpos)
     powerupName = "Bigger\nItem"; txtcolor = V_BLUEMAP;
    elseif (player.powerlap.item == plap.powitems.doubleamount) -- double amount
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[7]), icontrans|powflagpos)
     powerupName = "Double\nAmount"; txtcolor = V_PEACHMAP;
    elseif (player.powerlap.item == plap.powitems.fasterspark) -- faster spark
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[8]), icontrans|powflagpos)
     powerupName = "Faster\nSpark"; txtcolor = V_PURPLEMAP;
    elseif (player.powerlap.item == plap.powitems.supermode) -- super mode
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[9]), icontrans|powflagpos)
     powerupName = "Super\nMode"; txtcolor = V_GOLDMAP;
    elseif (player.powerlap.item == plap.powitems.punchbumper) -- punch bumper
     powerupName = "Punch\nBumper"; txtcolor = V_REDMAP; 
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[10]), icontrans|powflagpos)
    elseif (player.powerlap.item == plap.powitems.bananarain) -- banana rain
     powerupName = "Banana\nRain"; txtcolor = V_GOLDMAP;
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[11]), icontrans|powflagpos)
    elseif (player.powerlap.item == plap.powitems.itemrecollect) -- item recollect
     powerupName = "Item\nRecollect"; txtcolor = V_TEAMAP;
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[12]), icontrans|powflagpos)
    elseif (player.powerlap.item == plap.powitems.growingseed) -- growing seed
     powerupName = "Growing\nSeed"; txtcolor = V_SKYMAP;
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[13]), icontrans|powflagpos)
    elseif (player.powerlap.item == plap.powitems.curseattack) -- curse attack
    powerupName = "Curse\nAttack"; txtcolor = V_LAVENDERMAP;
    v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[14]), icontrans|powflagpos)
    elseif (player.powerlap.item == plap.powitems.nothing) -- no powerup
     powerupName = "Sorry\nNothing"; txtcolor = 0; 
     v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[15]), icontrans|powflagpos)
    end

    -- powerup icon
    if player.powerlap.rolltimer > 0 v.drawScaled(FRACUNIT*powpositionX, FRACUNIT*powpositionY, FRACUNIT - powscaled, v.cachePatch(plap.powpatchs[plap.randompatch + 1]), V_HUDTRANS|powflagpos, 
    v.getColormap(TC_RAINBOW, player.mo.color)) 
    end;
    
    

    -- powerup text
    if player.powerlap.hudtime > TICRATE * 7 and player.powerlap.item != 0
     if (splitscreen == 0)
        if txtmovX > 0 txtmovX = $ - 2 end; -- do movement
        if leveltime%4 == 1 and txttrans != V_10TRANS txttrans = $ - FRACUNIT end;
        v.drawString(55 - txtmovX, powpositionY - 2, "" + powerupName, txttrans|V_ALLOWLOWERCASE|powflagpos|txtcolor)
     elseif (splitscreen == 1)
        if displayplayers[0] == player
            --if txtmovX > 0 txtmovX = $ - 2 end; -- do movement
            --if leveltime%4 == 1 and txttrans != V_10TRANS txttrans = $ - FRACUNIT end;
            v.drawString(75 - txtmovX, powpositionY - 2, "" + powerupName, txttrans|V_ALLOWLOWERCASE|powflagpos|txtcolor, "thin")
        elseif displayplayers[1] == player
            --if txtmovX > 0 txtmovX = $ - 2 end; -- do movement
            --if leveltime%4 == 1 and txttrans != V_10TRANS txttrans = $ - FRACUNIT end;
            v.drawString(75 - txtmovX, powpositionY - 2, "" + powerupName, txttrans|V_ALLOWLOWERCASE|powflagpos|txtcolor, "thin")
        end
     end
    else
        -- set values for next powerup given
        txtmovX = 20 
        if (splitscreen == 0) txttrans = V_90TRANS; else txttrans = V_10TRANS; end
    end


    -- manual use indication
    if (player.powerlapBTN == BT_ATTACK) powbutton = "ITEM"
    elseif (player.powerlapBTN == BT_CUSTOM1) powbutton = "CUSTOM 1"
    elseif (player.powerlapBTN == BT_CUSTOM2) powbutton = "CUSTOM 2"
    elseif (player.powerlapBTN == BT_CUSTOM3) powbutton = "CUSTOM 3"
    else powbutton = "non init?"
    end
    if (splitscreen == 0 or splitscreen == 1) and cv_powerlap_howtoplay.value
        if player.powerlap.powerready == true and player.powerlap.item >= 1 and player.powerlap.item <= 7 and player.powerlap.hudtime <= 1
            v.drawString(powpositionX, powpositionY + 23, "Press " + powbutton + " \n to use it" , V_HUDTRANS|V_ALLOWLOWERCASE|powflagpos|V_YELLOWMAP, "small")
        end
    end

    -- automatic discard indication
    if (splitscreen == 0 or splitscreen == 1) and cv_powerlap_howtoplay.value
        v.drawFill(powpositionX, powpositionY, 0 + player.powerlap.discardtime, 24 , 128)
    else
        v.drawFill(powpositionX, powpositionY, 0 + player.powerlap.discardtime*2/3, 24*2/3 , 128)
    end

    if (splitscreen == 0 or splitscreen == 1) and cv_powerlap_howtoplay.value
        if (player.powerlap.item >= 8 and player.powerlap.item <= 11 and player.powerlap.hudtime <= 1 and player.kartstuff[k_itemtype] == 0 and player.kartstuff[k_itemroulette] == 0 and player.kartstuff[k_itemheld] == 0 and not (player.kartstuff[k_position] == 1))
         or (player.powerlap.discardtime > 1)
                v.drawString(powpositionX, powpositionY + 23, "Hold " + powbutton + "\n to exchange \n with a sneaker" , V_HUDTRANS|V_ALLOWLOWERCASE|powflagpos|V_TEAMAP, "small")
        end
    end




    -- powerup timer
    if (splitscreen == 0 or splitscreen == 1)
        if player.powerlap.item != 0 and player.powerlap.inuse == true and player.powerlap.powtime > 0
            v.drawString(powpositionX, powpositionY + 25, "" + G_TicsToSeconds(player.powerlap.powtime) + "." + G_TicsToCentiseconds(player.powerlap.powtime)/10, V_HUDTRANS|V_ALLOWLOWERCASE|powflagpos, powtxtsize)
        end
    elseif (splitscreen >= 2)
        if player.powerlap.item != 0 and player.powerlap.inuse == true and player.powerlap.powtime > 0
            v.drawString(powpositionX, powpositionY + 15, "" + G_TicsToSeconds(player.powerlap.powtime) + "." + G_TicsToCentiseconds(player.powerlap.powtime)/10, V_HUDTRANS|V_ALLOWLOWERCASE|powflagpos, powtxtsize)
        end

    end
    -- end

    
    
    -- item recollect specefic
    if player.powerlap.item == plap.powitems.itemrecollect and player.powerlap.inuse == true and player.powerlap.powtime <= 2 and player.powerlap.collectitem != nil
        v.draw(powpositionX - 12, powpositionY - 12, v.cachePatch(K_GetItemPatch(player.powerlap.collectitem, true)), powflagpos)
    end

    -- growing seed specific
    if player.powerlap.item == plap.powitems.growingseed
        v.drawString(powpositionX, powpositionY - 5, ""  + player.powerlap.growtime/10 + "%", V_HUDTRANS|V_ALLOWLOWERCASE|powflagpos|growtxtcolor, powtxtsize)
        --v.drawString(powpositionX, powpositionY + 30, "" + G_TicsToSeconds(player.powerlap.powtime) + "." + G_TicsToCentiseconds(player.powerlap.powtime)/10, V_HUDTRANS|V_ALLOWLOWERCASE|powflagpos, powtxtsize)
    end

    -- distance debug
    -- if displayplayers[0] == player
    --     v.drawString(25, 150, R_PointToDist2(player.mo.x,player.mo.y,first.x,first.y)/FRACUNIT)
    -- end
    end
end

hud.add(powerlaphud, "game" )