-- cvars
rawset(_G, "cv_powerlap", CV_RegisterVar({
    name = "powerlap",
    defaultvalue = 1,
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
}))

rawset(_G, "cv_powerlap_powforfirst", CV_RegisterVar({
    name = "powlap_firstpow",
    defaultvalue = 1,
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
}))

rawset(_G, "cv_powerlap_powonstart", CV_RegisterVar({
    name = "powlap_powonstart",
    defaultvalue = 0,
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
}))

rawset(_G, "cv_powerlap_howtoplay", CV_RegisterVar({
    name = "pl_howtoplay",
    defaultvalue = 1,
    flags = CV_SHOWMODIF,
    PossibleValue = CV_OnOff
}))

local executed = false;
-- Execute on start
addHook("MapLoad", function()
    if executed == false and cv_powerlap.value
        chatprint("\x8f Server is running  Powerlap, \x8fYou can type \x8c'pl_help' \x8fin console for more info");
        executed = true;
    end
end)

----------------------------------------
-- Commends
COM_AddCommand("pl_button", function(player, pattern)
    if pattern == nil -- empty
        CONS_Printf(player, "\x89 changes the button for using the manual powerup",
         "options are: item, custom1, custom2, custom3");
    return end

    if player.powerlap
        pattern = string.lower(pattern) -- always lowercase
        if pattern == "item" player.powerlapBTN = BT_ATTACK
        elseif pattern == "custom1" or pattern == "custom 1" player.powerlapBTN = BT_CUSTOM1
        elseif pattern == "custom2" or pattern == "custom 2" player.powerlapBTN = BT_CUSTOM2
        elseif pattern == "custom3" or pattern == "custom 3" player.powerlapBTN = BT_CUSTOM3
        else CONS_Printf(player, "\x89 changes the button for using the manual powerup",
            "options are: item, custom1, custom2, custom3");
        end
    end
end)

COM_AddCommand("pl_shieldtype", function(player, pattern)
    if pattern == nil -- empty
        CONS_Printf(player, "\x89 changes the astetic of the powerup shield",
         "options are: \x8b Pity \x84 Force \x8a Attract \x82 Whirlwind \x88 Elemental \x85 Armageddon");
    return end

    pattern = string.lower(pattern) -- always lowercase
    if (pattern == "pity") or (pattern == "normal") or (pattern == "green") -- pity
        player.MTshield = MT_PITYORB
    elseif (pattern == "force") or (pattern == "shield") or (pattern == "blue") -- force
        player.MTshield = MT_BLUEORB
    elseif (pattern == "attract") or (pattern == "electric") or (pattern == "yellow") -- attract
        player.MTshield = MT_YELLOWORB
    elseif (pattern == "whirlwind") or (pattern == "tornado") or (pattern == "white") -- whirlwind
        player.MTshield = MT_WHITEORB
    elseif (pattern == "elemental") or (pattern == "water") or (pattern == "fire") -- elemental
        player.MTshield = MT_GREENORB
    elseif (pattern == "armageddon") or (pattern == "atomic") or (pattern == "red") -- armageddon
        player.MTshield = MT_BLACKORB
    else -- mistake
        CONS_Printf(player, "\x89 changes the astetic of the powerup shield",
        "options are: \x8b Pity \x84 Force \x8a Attract \x82 Whirlwind \x88 Elemental \x85 Armageddon");
        return;
    end
end)

COM_AddCommand("pl_supercolor", function(player, pattern)
    if not (player.supercolor) player.supercolor = {i = 1, j = 1, picked = nil} end;
    if pattern == nil -- empty
        CONS_Printf(player, "\x89 changes the color during super mode",
         "options are: \x8a Gold \x87 Orange \x85 Red \x81 Purple \x84 Blue \x88 Aqua \x83 Green  \x80 White \x8f Cream");
    return end

    pattern = string.lower(pattern) -- always lowercase
    if (pattern == "gold") or (pattern == "yellow") or (pattern == "sonic")
        player.supercolor.picked = 101
    elseif (pattern == "orange") or (pattern == "tails")
        player.supercolor.picked = 106
    elseif (pattern == "red") or (pattern == "knuckles")
        player.supercolor.picked = 111
    elseif (pattern == "purple")
        player.supercolor.picked = 116
    elseif (pattern == "blue")
        player.supercolor.picked = 121
    elseif (pattern == "aqua")
        player.supercolor.picked = 126
    elseif (pattern == "green")
        player.supercolor.picked = 131
    elseif (pattern == "white")
        player.supercolor.picked = 136
    elseif (pattern == "cream")
        player.supercolor.picked = 141
    else -- mistake
        CONS_Printf(player, "\x89 changes the color during super mode",
        "options are: \x8a Gold \x87 Orange \x85 Red \x81 Purple \x84 Blue \x88 Aqua \x83 Green \x80 White \x8f Cream");
    end
end)

COM_AddCommand("pl_help", function(player, pattern)
    CONS_Printf(player, "\x8fPowerlap is an addon that gives a special item every lap, There are 3 types of powerups:",
    "\x82 -- MANUAL USE  -- Icon with a YELLOW border, you can use them by pressing the ITEM button while carring nothing",
    "\x8b --  AUTO USE   -- Icon with a GREEN border, they will be used during certain condition, like using an corresponding item",
    "\x86 -- INSTANT USE -- Icon with a GREY border, it will be used as soon you got that powerup",
    "\x8f  You can change the look of the shield by typing \x8c'pl_shieldtype' \x8fin console and the super mode color with \x8c'pl_supercolor'",
    "\x8f Type 'pl_list' in console for the list of powerups")
end)

COM_AddCommand("pl_list", function(player, pattern)
    local stupidtext = { " Mini boost: ", "Grants a short duration drift boost", 
    " Long boost: ", "Grants a long duration drift boost",
    " Spring drop: ", "Place a spring trap and make you hover the ground",
    " Mini hyudoro: ", "Grants invisibility",
    " Banana rain: ", "Rains bananas around you",
    " Punch bumper: ", "Wipe any player you touch",
    " Growing seed: ", "Give grow, size and duration increases the longer this powerup is held",
    " Protect shield: ", "Protect from 1 hit",
    " Bigger item: ", "Make the next item bigger",
    " Double amount: ", "Double the amount of the next item",
    " Curse attack: ", "Shrinks victims of your items",
    " Super mode: ", "???",
    " Faster spark: ", "Drift sparks are stronger for a short time",
    " Item recollect: ", "Get the item you just took, or a sneaker if time ran out"}
    for key,i in ipairs(stupidtext) do
    if key%2 == 1 CONS_Printf(player, "\x82"+ i + "\x80"+ stupidtext[key+1]) end
    end
end)

COM_AddCommand("pl_force", function(player, pattern)
	if pattern == "" or pattern == nil
        CONS_Printf(player, "\x82 type the name of the powerup (without spaces), or the ID number");
    elseif pattern == "miniboost" player.powerlap.item = plap.powitems.miniboost;
    elseif pattern == "longboost" player.powerlap.item = plap.powitems.longboost;
    elseif pattern == "springdrop" player.powerlap.item = plap.powitems.springdrop;
    elseif pattern == "minihyudoro" player.powerlap.item = plap.powitems.minihyudoro;
    elseif pattern == "bananarain" player.powerlap.item = plap.powitems.bananarain;
    elseif pattern == "punchbumper" player.powerlap.item = plap.powitems.punchbumper;
    elseif pattern == "growingseed" player.powerlap.item = plap.powitems.growingseed;
    elseif pattern == "protectshield" player.powerlap.item = plap.powitems.protectshield;
    elseif pattern == "biggeritem" player.powerlap.item = plap.powitems.biggeritem;
    elseif pattern == "doubleamount" player.powerlap.item = plap.powitems.doubleamount;
    elseif pattern == "curseattack" player.powerlap.item = plap.powitems.curseattack;
    elseif pattern == "fasterspark" player.powerlap.item = plap.powitems.fasterspark;
    elseif pattern == "supermode" player.powerlap.item = plap.powitems.supermode;
    elseif pattern == "itemrecollect" player.powerlap.item = plap.powitems.itemrecollect;
    elseif pattern
		pattern = tonumber(pattern)
        player.powerlap.item = pattern; -- we type the ID of the powerup
		player.powerlap.hudtime = TICRATE * 10
    else
        CONS_Printf(player, "no match found");
    end
end, 1)

COM_AddCommand("powlap_toggle", function(player, pattern)
	if pattern == "" or pattern == nil
        CONS_Printf(player, "\x82 type the name of the powerup (without spaces), or the ID number"); return
    elseif pattern == "miniboost" if plap.powtoggle[1] == true plap.powtoggle[1] = false else plap.powtoggle[1] = true end
    elseif pattern == "longboost" if plap.powtoggle[2] == true plap.powtoggle[2] = false else plap.powtoggle[2] = true end
    elseif pattern == "springdrop" if plap.powtoggle[3] == true plap.powtoggle[3] = false else plap.powtoggle[3] = true end
    elseif pattern == "minihyudoro" if plap.powtoggle[4] == true plap.powtoggle[4] = false else plap.powtoggle[4] = true end
    elseif pattern == "bananarain" if plap.powtoggle[5] == true plap.powtoggle[5] = false else plap.powtoggle[5] = true end
    elseif pattern == "punchbumper" if plap.powtoggle[6] == true plap.powtoggle[6] = false else plap.powtoggle[6] = true end
    elseif pattern == "growingseed" if plap.powtoggle[7] == true plap.powtoggle[7] = false else plap.powtoggle[7] = true end
    elseif pattern == "protectshield" if plap.powtoggle[8] == true plap.powtoggle[8] = false else plap.powtoggle[8] = true end
    elseif pattern == "biggeritem" if plap.powtoggle[9] == true plap.powtoggle[9] = false else plap.powtoggle[9] = true end
    elseif pattern == "doubleamount" if plap.powtoggle[10] == true plap.powtoggle[10] = false else plap.powtoggle[10] = true end
    elseif pattern == "curseattack" if plap.powtoggle[11] == true plap.powtoggle[11] = false else plap.powtoggle[11] = true end
    elseif pattern == "fasterspark" if plap.powtoggle[12] == true plap.powtoggle[12] = false else plap.powtoggle[12] = true end
    elseif pattern == "supermode" if plap.powtoggle[13] == true plap.powtoggle[13] = false else plap.powtoggle[13] = true end
    elseif pattern == "itemrecollect" if plap.powtoggle[14] == true plap.powtoggle[14] = false else plap.powtoggle[14] = true end
    elseif pattern
		pattern = tonumber(pattern)
        if plap.powtoggle[pattern] == true plap.powtoggle[pattern] = false else plap.powtoggle[pattern] = true end
    else
        CONS_Printf(player, "no match found");
    end
    print("" + pattern + "has been toggled") -- check
end, 1)




-- I/O config
local powload = false;
local function iopowerlap()
    if powload == false
        if not consoleplayer powload = true return end;
        local file = io.open("powerlap.cfg", "r"); -- check if file exsist
        if file == nil -- file does not exsist
            -- so write the new commends
            file = io.open("powerlap.cfg", "w");
            file:write("pl_shieldtype force;\n");
            file:write("pl_supercolor gold;\n");
            file:write("pl_howtoplay on;\n");
            file:write("pl_button item;\n");
            file:close()
        end
        -- read the file
        file = io.open("powerlap.cfg", "r");
        local commends = file:read();
        while commends -- read every line of the file
            COM_BufInsertText(consoleplayer, commends);
            commends = file:read();
        end
        file:close();
    end
    powload = true; -- load only once
end
addHook("ThinkFrame", iopowerlap);
addHook("IntermissionThinker", iopowerlap);
addHook("VoteThinker", iopowerlap);