-- sync global variables
rawset(_G, "plap", {
    powitems = {miniboost = 1, longboost = 2, springdrop = 3, minihyudoro = 4, bananarain = 5, punchbumper = 6, growingseed = 7, protectshield = 8, biggeritem = 9, 
    doubleamount = 10, curseattack = 11, fasterspark = 12, supermode = 13, itemrecollect = 14,
    nothing = 99},
    powtoggle = {true       , true         , true          , true           , true          , true           , true           , true             , true          , true,
    true             , true            , true            , true          , true              , true},
    
    powpatchs = {"POWLMB", "POWLLB", "POWLSD", "POWLPS", "POWLMH", "POWLBI", "POWL2X", "POWLFS", "POWLSM", "POWLPB", "POWLBR", "POWLIR", "POWLGS", "POWLCA", "POWLNO"},
    randompatch = 1,
    first = {x = nil, y = nil}
});

rawset(_G, "powerlap", {
    powerready = false, -- button check
    lastlap = 0, -- lap update
    item = 0, -- powerup player has
    shield = nil, -- shield mobj check
    --MTshield = $.MTshield, -- shield picked
    --supercolor = {i = 1, j = 1, picked = $.supercolor.picked}, -- super mode color
    rolltimer = -1, -- roll timer
    hudtime = 0, -- hud stuff
    powtime = 0, -- timer for stuff
    growtime = 0, -- timer for grow seed
    decay = 0, -- decay for using manual pow
    discardtime = 0, -- timer for discard auto pows
    firstplace = {x = nil, y = nil}, -- player distance
    inuse = false, -- powerup is in use
    hasspbitem = false, -- spb check for bonus
    --button = BT_ATTACK,

    -- top half items
    -- higher is the amount of frames, higher is the chance of getting this powerup
    toptier_L = {{id = plap.powitems.miniboost, frames = 12}, {id = plap.powitems.longboost, frames = 0},
        {id = plap.powitems.springdrop, frames = 0}, {id = plap.powitems.protectshield, frames = 8}, {id = plap.powitems.minihyudoro, frames = 4},
        {id = plap.powitems.biggeritem, frames = 4}, {id = plap.powitems.doubleamount, frames = 2}, {id = plap.powitems.fasterspark, frames = 4},
        {id = plap.powitems.supermode, frames = 0}, {id = plap.powitems.punchbumper, frames = 4}, {id = plap.powitems.bananarain, frames = 6},
        {id = plap.powitems.itemrecollect, frames = 0}, {id = plap.powitems.growingseed, frames = 0}, {id = plap.powitems.curseattack, frames = 4},
                totalframes = 0},
    toptier_M = {{id = plap.powitems.miniboost, frames = 8}, {id = plap.powitems.longboost, frames = 2},
        {id = plap.powitems.springdrop, frames = 2}, {id = plap.powitems.protectshield, frames = 6}, {id = plap.powitems.minihyudoro, frames = 4},
        {id = plap.powitems.biggeritem, frames = 0}, {id = plap.powitems.doubleamount, frames = 0}, {id = plap.powitems.fasterspark, frames = 6},
        {id = plap.powitems.supermode, frames = 0}, {id = plap.powitems.punchbumper, frames = 4}, {id = plap.powitems.bananarain, frames = 6},
        {id = plap.powitems.itemrecollect, frames = 6}, {id = plap.powitems.growingseed, frames = 0}, {id = plap.powitems.curseattack, frames = 4},
                totalframes = 0},
    toptier_H = {{id = plap.powitems.miniboost, frames = 2}, {id = plap.powitems.longboost, frames = 8},
        {id = plap.powitems.springdrop, frames = 4}, {id = plap.powitems.protectshield, frames = 0}, {id = plap.powitems.minihyudoro, frames = 0},
        {id = plap.powitems.biggeritem, frames = 4}, {id = plap.powitems.doubleamount, frames = 4}, {id = plap.powitems.fasterspark, frames = 4},
        {id = plap.powitems.supermode, frames = 1}, {id = plap.powitems.punchbumper, frames = 0}, {id = plap.powitems.bananarain, frames = 0},
        {id = plap.powitems.itemrecollect, frames = 2}, {id = plap.powitems.growingseed, frames = 4}, {id = plap.powitems.curseattack, frames = 0},
                totalframes = 0},

    -- bottom half items
    bottomtier_L = {{id = plap.powitems.miniboost, frames = 6}, {id = plap.powitems.longboost, frames = 2},
        {id = plap.powitems.springdrop, frames = 0}, {id = plap.powitems.protectshield, frames = 4}, {id = plap.powitems.minihyudoro, frames = 4},
        {id = plap.powitems.biggeritem, frames = 4}, {id = plap.powitems.doubleamount, frames = 2}, {id = plap.powitems.fasterspark, frames = 6},
        {id = plap.powitems.supermode, frames = 0}, {id = plap.powitems.punchbumper, frames = 6}, {id = plap.powitems.bananarain, frames = 0},
        {id = plap.powitems.itemrecollect, frames = 2}, {id = plap.powitems.growingseed, frames = 0}, {id = plap.powitems.curseattack, frames = 4},
                totalframes = 0},
    bottomtier_M = {{id = plap.powitems.miniboost, frames = 2}, {id = plap.powitems.longboost, frames = 6},
        {id = plap.powitems.springdrop, frames = 4}, {id = plap.powitems.protectshield, frames = 0}, {id = plap.powitems.minihyudoro, frames = 4},
        {id = plap.powitems.biggeritem, frames = 0}, {id = plap.powitems.doubleamount, frames = 2}, {id = plap.powitems.fasterspark, frames = 4},
        {id = plap.powitems.supermode, frames = 1}, {id = plap.powitems.punchbumper, frames = 0}, {id = plap.powitems.bananarain, frames = 0},
        {id = plap.powitems.itemrecollect, frames = 6}, {id = plap.powitems.growingseed, frames = 4}, {id = plap.powitems.curseattack, frames = 0},
                totalframes = 0},
    bottomtier_H = {{id = plap.powitems.miniboost, frames = 0}, {id = plap.powitems.longboost, frames = 10},
        {id = plap.powitems.springdrop, frames = 0}, {id = plap.powitems.protectshield, frames = 0}, {id = plap.powitems.minihyudoro, frames = 0},
        {id = plap.powitems.biggeritem, frames = 6}, {id = plap.powitems.doubleamount, frames = 6}, {id = plap.powitems.fasterspark, frames = 0},
        {id = plap.powitems.supermode, frames = 2}, {id = plap.powitems.punchbumper, frames = 0}, {id = plap.powitems.bananarain, frames = 0},
        {id = plap.powitems.itemrecollect, frames = 0}, {id = plap.powitems.growingseed, frames = 6}, {id = plap.powitems.curseattack, frames = 0},
                totalframes = 0},

    -- first place items (if turned on)
    firsttier = {{id = plap.powitems.miniboost, frames = 6}, {id = plap.powitems.longboost, frames = 0},
        {id = plap.powitems.springdrop, frames = 0}, {id = plap.powitems.protectshield, frames = 4}, {id = plap.powitems.minihyudoro, frames = 0},
        {id = plap.powitems.biggeritem, frames = 0}, {id = plap.powitems.doubleamount, frames = 1}, {id = plap.powitems.fasterspark, frames = 2},
        {id = plap.powitems.supermode, frames = 0}, {id = plap.powitems.punchbumper, frames = 0}, {id = plap.powitems.bananarain, frames = 0},
        {id = plap.powitems.itemrecollect, frames = 0}, {id = plap.powitems.growingseed, frames = 0}, {id = plap.powitems.curseattack, frames = 4},
            totalframes = 0},
})

freeslot("S_PITY11", "S_PITY12")
-- reconfigure some animation frames
states[S_PITY1] = {SPR_PITY, FF_TRANS30|A  , 4, nil, 0, 0, S_PITY2 }
states[S_PITY2] = {SPR_PITY, FF_TRANS30|B  , 4, nil, 0, 0, S_PITY3 }
states[S_PITY3] = {SPR_PITY, FF_TRANS30|C  , 4, nil, 0, 0, S_PITY4 }
states[S_PITY4] = {SPR_PITY, FF_TRANS30|D  , 4, nil, 0, 0, S_PITY5 }
states[S_PITY5] = {SPR_PITY, FF_TRANS30|E  , 4, nil, 0, 0, S_PITY6 }
states[S_PITY6] = {SPR_PITY, FF_TRANS30|F  , 4, nil, 0, 0, S_PITY7 }
states[S_PITY7] = {SPR_PITY, FF_TRANS30|G  , 4, nil, 0, 0, S_PITY8 }
states[S_PITY8] = {SPR_PITY, FF_TRANS30|H  , 4, nil, 0, 0, S_PITY9 }
states[S_PITY9] = {SPR_PITY, FF_TRANS30|I  , 4, nil, 0, 0, S_PITY10 }
states[S_PITY10] = {SPR_PITY, FF_TRANS30|J  , 4, nil, 0, 0, S_PITY11 }
states[S_PITY11] = {SPR_PITY, FF_TRANS30|K  , 4, nil, 0, 0, S_PITY12 }
states[S_PITY12] = {SPR_PITY, FF_TRANS30|L  , 4, nil, 0, 0, S_PITY1 }
